#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
A simple example to create a graphviz dot file and draw a graph.

"""
#    Copyright (C) 2006 by 
#    Aric Hagberg <hagberg@lanl.gov>
#    Dan Schult <dschult@colgate.edu>
#    Manos Renieris, http://www.cs.brown.edu/~er/
#    Distributed with BSD license.     p
#    All rights reserved, see LICENSE for details.
__author__ = """Aric Hagberg (hagberg@lanl.gov)"""

from networkx import *
                      
from math import *
from pygraphviz import *


import os


print "**************************"
print "*** BTs  PA - PAF EXP ****"
print "**************************"

lam=range(1,4)


print "lambda rand_per bip clique_numb coef_clust diam rad l"

for ip in lam:
  r=range(1, 16)
  for kp in r:
        kp=kp/100.0
        direc= str(ip)+"-"+str(kp)
        os.chdir(direc)

	ejes=0
	clique_num=0
	coef_clust= 0
	diam= 0
	rad = 0
	l_tot = 0
	grados = {}

	maximo=30.0
	r=range(1,31)
	for f in r:
	   na="modelo_"+str(f)+".edgelist"
	   BT=read_edgelist(na)
	   #minimum of all pairs shortest path.
	   
	   if is_connected(BT):
		l=all_pairs_shortest_path_length(BT)
		nodes=nodes_iter(BT)
		p=0
		acum=0.0
		for i in nodes:
			for j in nodes:
			  if (i != j):
	     			p=p+l[i][j]
				acum=acum+1.0
		p=p/acum
		l_tot=l_tot+p
	   else:
		p="NC"
	   
	   ejes=ejes+ BT.number_of_edges()
	   clique_num= clique_num + graph_clique_number(BT)
	   coef_clust= coef_clust + average_clustering(BT)
	   diam= diam + diameter(BT)
	   rad = rad + radius(BT)
	   
	  # for n in BT:
	#	  grados[n] = grados[n] + BT.degree(n)

	print str(ip)+ " "+ str(kp)+" "+str(clique_num/maximo)+ " " + str(coef_clust/maximo)+  " " + str(diam/maximo)+" "+ str(rad/maximo) + " "+ str(l_tot/maximo)
        os.chdir('..')

