#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
A simple example to create a graphviz dot file and draw a graph.

"""
#    Copyright (C) 2006 by 
#    Aric Hagberg <hagberg@lanl.gov>
#    Dan Schult <dschult@colgate.edu>
#    Manos Renieris, http://www.cs.brown.edu/~er/
#    Distributed with BSD license.     p
#    All rights reserved, see LICENSE for details.
__author__ = """Aric Hagberg (hagberg@lanl.gov)"""

from networkx import *
                      
from math import *
from pygraphviz import *
from statlib import stats

import os

ddbits = [1, 2, 2, 3, 2, 1, 17, 27, 21, 12, 24, 3, 10, 9, 23, 14, 5, 53, 5, 18, 9, 4, 7, 2, 37, 4, 2, 14, 5, 24, 28, 32, 61, 38, 15, 78, 50, 23, 1, 1, 37, 11, 10, 88, 1, 20, 23, 2, 7, 9, 5, 18, 35, 71, 4, 14, 2, 30, 3, 8, 22, 29, 21, 13, 66, 24, 4, 2, 18, 4, 2, 5, 17, 15, 12, 6, 37, 7, 27, 29, 41, 9, 5, 96, 48, 5, 12, 10, 7, 1, 124, 16, 34, 2, 5, 8, 3, 5, 10, 14, 1, 22, 6, 20, 23, 24, 22, 2, 6, 64, 23, 41, 92, 43, 7, 36, 21, 36, 51, 19, 22, 9, 32, 8, 2, 60, 20, 3, 4, 10, 16, 15, 17, 15, 7, 12, 3, 31, 5, 1, 63, 43, 24, 87, 2, 6, 43, 2, 53, 21, 50, 39, 29, 55, 17, 2, 5, 24, 19, 28, 46, 30, 1, 46, 97, 31, 1, 2, 33, 55, 40, 2, 51, 13, 79]


print "**************************"
print "*** BTs  F - PAF EXP ****"
print "**************************"

lam=range(1,2)
r1=range(20,21,5)
b1= range(98,99,2)
r2 = range(6,8,2)
b2 = range(80,86,5)
r3 = range(6,8,2)
b3 = range(50,56,5)


print "lambda r1 b1 r2 b2 r3 b3 clique_numb coef_clust diam rad l"

for ll in lam:
  for rr1 in r1:
    rr1 = rr1 /100.0
    for bb1 in b1:
      bb1 = bb1/100.0
      for rr2 in r2:
        rr2 = rr2/100.0
        for bb2 in b2:
          bb2 = bb2/100.0
          for rr3 in r3:
            rr3 = rr3 /100.0
            for bb3 in b3:
            
          
            
                bb3 = bb3 /100.0
                direc= str(ll)+"-"+str(rr1)+"-"+str(bb1)+"-"+str(rr2)+"-"+str(bb2)+"-"+str(rr3)+"-"+str(bb3)
                os.chdir(direc)

	      
		clique_num=[]
		coef_clust= []
		diam= []
		rad = []
		l_tot = []
		rech = 0

	
		r=range(1,16)
		for f in r:
		   na="modelo_"+str(f)+".edgelist"
		   BT=read_edgelist(na)
		   #minimum of all pairs shortest path.
		   
		   if is_connected(BT):
			l=all_pairs_shortest_path_length(BT)
			nodes=nodes_iter(BT)
			p=0
			acum=0.0
			for i in nodes:
				for j in nodes:
				  if (i != j):
		     			p=p+l[i][j]
					acum=acum+1.0
			p=p/acum
			l_tot.append(p)
		   else:
			p="NC"
		   
		   clique_num.append(graph_clique_number(BT))
		   coef_clust.append(average_clustering(BT))
		   diam.append(diameter(BT))
		   rad.append(radius(BT))
		   
		   nodes = BT.nodes()
		   dd = BT.degree(nodes)
		   
		   [a1,p] = stats.lks_2samp(ddbits,dd)
		   if (p < 0.05) :
		      rech = rech+1
		  # for n in BT:
		  #  grados[n] = grados[n] + BT.degree(n)
		cnbits= 13
		ccbits= 0.4537
		diambits=4
		radbits=2
		lbits=1.982

		cn = stats.mean(clique_num)
		scn = stats.stdev(clique_num)
		cc = stats.mean(coef_clust)
		scc = stats.stdev(coef_clust)
		dia = stats.mean(diam)
		sdia = stats.stdev(diam)
		ra = stats.mean(rad)
		sra = stats.stdev(rad)
		l = stats.mean(l_tot)
		sl = stats.stdev(l_tot)
		
		if scn == 0:
		  if cn-cnbits == 0:
		    gcn = 0
		  else:
		    gcn = 100000
		else: 
		   gcn = abs(cn-cnbits)/scn


		if scc == 0:
		  if cc-ccbits == 0:
		    gcc = 0
		  else:
		    gcc = 100000
		else: 
		   gcc = abs(cc-ccbits)/scc

		if sra == 0:
		  if ra-radbits == 0:
		    gra = 0
		  else:
		    gra = 100000
		else: 
		   gra = abs(ra-radbits)/sra

		if sdia == 0:
		  if dia-diambits == 0:
		    gdia = 0
		  else:
		    gdia = 100000
		else: 
		   gdia = abs(dia-diambits)/sdia

		if sl == 0:
		  if l-lbits == 0:
		    gl = 0
		  else:
		    gl = 100000
		else: 
		   gl = abs(l-lbits)/sl

		gof = (1/cnbits)* gcn + (6/ccbits)*gcc + (1/diambits)*gdia + (1/radbits)*gra + (6/lbits)*gl 

		print ll,rr1,bb1,rr2,bb2,rr3,bb3,cn, scn, cc, scc, dia, sdia, ra, sra, l, sl, gof, rech

		os.chdir('..')

