require 'paises.rb'
require 'gratr/import'
require 'rubygems'
require 'rubystats/exponential_distribution'

def armar_dict_paises(f,lambda)
  paises = {}

  f.each do |l|
    a = l.gsub(/\n/, '').split(/\;\s*/)
    id = a[0]
    nom = a[1]
    reg = a[2]
    des = a[3]
    paises[nom] = Pais.new(id,nom,reg,des)
    paises[nom].fitness = set_fitness(lambda)
  end	

  paises

end

def armar_dict_anos(f,paises)
  ano_in={}

  f.each do |l|
    a=l.gsub(/\n/, '').split(/\;\s*/)
    pais=a[0]
    ano=a[1].to_i
    ano_in[ano]=[] unless ano_in.has_key?(ano)
    ano_in[ano]<< pais
    paises[pais].ano_in=ano
    paises[pais].des = set_dev(ano)
    #puts paises[pais].des
  end
	
  ano_in
end

def armar_dict_cant_bt(f)
  bts={}

  f.each do |l|
    a=l.gsub(/\n/, '').split(/\;\s*/)
    ano=a[0].to_i
    cant_bt=a[1].to_i
    bts[ano]=cant_bt
  end

  bts

end

def armar_grafo_original_hasta(dict_paises,archivo_bt,ano_fin)


  grafo = UndirectedGraph.new()

  dict_paises.keys.each{|p| grafo.add_vertex!(p) }

  f_bt = File.new(archivo_bt).readlines
  f_bt.each do |l|
    a = l.gsub(/\n/, '').split(/\;\s*/)
    p1 = a[0]
    p2 = a[1]
    ano = a[2].to_i
    #puts p1 + ' - ' + p2
    grafo.add_edge!(p1,p2, ano) unless ano > ano_fin
  end	
  
  grafo

end

def elegir_nodo_PA(paises_activos, dicc_paises, grafo)
  grados_total=0
  acum = []

  paises_activos.each do |p| 
    grados_total += grafo.degree(p)
    acum << grados_total
  end

  m=rand(0)
  m=m*grados_total
  rand(0)
  i=0

  while (acum[i]<m) 
	 i+=1
  end

  paises_activos[i]
  
end

def elegir_nodo_PA_fitness(paises_activos, dicc_paises, grafo)
  fit_por_BT_total=0
  acum = []
  paises_activos.each do |p| 
    fit_por_BT_total += dicc_paises[p].fitness*grafo.degree(p) #
    acum << fit_por_BT_total
  end
  rand(0)
  rand(0)
  m=rand(0)
  rand(0)
  m=m*fit_por_BT_total

  i=0

  while (acum[i]<m) 
	 i=i+1
  end

  paises_activos[i]
  
end

def elegir_nodo_PA_fitness(paises_activos, dicc_paises, grafo)
  fit_por_BT_total=0
  acum = []
  paises_activos.each do |p| 
    fit_por_BT_total += dicc_paises[p].fitness*grafo.degree(p) #
    acum << fit_por_BT_total
  end
  rand(0)
  m=rand(0)
  rand(0)
  m=m*fit_por_BT_total

  i=0

  while (acum[i]<m) 
	 i=i+1
  end

  paises_activos[i]
  
end


def elegir_nodo_fitness(paises_activos, dicc_paises, grafo)
  fit_total=0
  acum = []
  paises_activos.each do |p| 
    fit_total += dicc_paises[p].fitness#
    acum << fit_total
  end

  m=rand(0)
  m=m*fit_total

  i=0

  while (acum[i]<m) 
	 i=i+1
  end

  paises_activos[i]
  
end



def set_fitness (lambda=1)
  expd = Rubystats::ExponentialDistribution.new(lambda)
  a=  expd.rng
  #puts a
  a
end

def set_dev(ano)
   m=rand(0)
   if (ano <1976)
	   if (m < 0.2068)
	     a=0
	   else
	     a=1
	   end
   else
     if (ano<1986)
       if (m < 0.2666)
	 a=0
       else
	 a=1
       end
     else
       if (m < 0.1648)
	 a=0
       else
	 a=1
       end
     end
   end
   a
end

