#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
A simple example to create a graphviz dot file and draw a graph.

"""
#    Copyright (C) 2006 by 
#    Aric Hagberg <hagberg@lanl.gov>
#    Dan Schult <dschult@colgate.edu>
#    Manos Renieris, http://www.cs.brown.edu/~er/
#    Distributed with BSD license.     p
#    All rights reserved, see LICENSE for details.
__author__ = """Aric Hagberg (hagberg@lanl.gov)"""

from networkx import *
                      
from math import *
from pygraphviz import *
from statlib import stats

import os


print "**************************"
print "*** BTs  PA - PAF EXP ****"
print "**************************"

ddbits = [1, 3, 2, 4, 3, 2, 19, 44, 24, 28, 16, 5, 16, 13, 23, 14, 5, 63, 13, 18, 9, 4, 15, 2, 60, 8, 12, 2, 17, 5, 25, 30, 35, 61, 45, 29, 82, 54, 46, 26, 5, 1, 62, 20, 13, 100, 5, 23, 23, 4, 1, 11, 16, 5, 25, 44, 91, 4, 18, 2, 35, 4, 12, 36, 44, 25, 18, 80, 5, 23, 4, 2, 4, 12, 32, 20, 18, 16, 52, 18, 34, 39, 56, 10, 5, 118, 49, 11, 17, 12, 9, 6, 2, 132, 25, 39, 2, 15, 19, 5, 5, 25, 15, 1, 2, 29, 12, 20, 35, 31, 32, 5, 15, 66, 25, 48, 99, 46, 28, 41, 28, 44, 61, 28, 24, 15, 49, 9, 6, 83, 22, 14, 8, 32, 21, 15, 18, 28, 10, 20, 3, 39, 7, 1, 74, 49, 29, 94, 2, 12, 52, 5, 62, 21, 60, 19, 35, 56, 23, 3, 5, 25, 25, 34, 59, 38, 1, 60, 110, 35, 1, 3, 52, 60, 56, 7, 58, 16, 93]



print "lambda rp cn scn cc scc diam sdiam rad srad l sl gof rec"

lam=[1,2]

for ip in lam:
  rp=range(0,16,5)
  for kp in rp:
        kp=kp/100.0
        direc= str(ip)+"-"+str(kp)
        os.chdir(direc)

	
	clique_num=[]
	coef_clust= []
	diam= []
	rad = []
	l_tot = []
        rech = 0

	maximo=50.0
	r=range(1,21)
	for f in r:
	   na="modelo_"+str(f)+".edgelist"
	   BT=read_edgelist(na)
	   #minimum of all pairs shortest path.
	   
	   #if is_connected(BT):
	   l=all_pairs_shortest_path_length(BT)
	   nodes=nodes_iter(BT)
	   p=0
	   acum=0.0
	   for i in nodes:
	     for j in nodes:
	       if (i != j):
	     	 p=p+l[i][j]
		 acum=acum+1.0
	   p=p/acum
	   l_tot.append(p)
	   
	   clique_num.append(graph_clique_number(BT))
	   coef_clust.append(average_clustering(BT))
	   diam.append(diameter(BT))
	   rad.append(radius(BT))
           
           nodes = BT.nodes()
           dd = BT.degree(nodes)
           
           [a1,p] = stats.lks_2samp(ddbits,dd)
           if (p < 0.05) :
	      rech = rech+1
	  # for n in BT:
	  #  grados[n] = grados[n] + BT.degree(n)
        cnbits= 14
        ccbits= 0.492
        diambits=4
        radbits=2
        lbits=1.926

        cn = stats.mean(clique_num)
        scn = stats.stdev(clique_num)
        cc = stats.mean(coef_clust)
        scc = stats.stdev(coef_clust)
        dia = stats.mean(diam)
        sdia = stats.stdev(diam)
        ra = stats.mean(rad)
        sra = stats.stdev(rad)
        l = stats.mean(l_tot)
        sl = stats.stdev(l_tot)
        
        if scn == 0:
          if cn-cnbits == 0:
            gcn = 0
          else:
            gcn = 100000
        else: 
           gcn = abs(cn-cnbits)/scn


        if scc == 0:
          if cc-ccbits == 0:
            gcc = 0
          else:
            gcc = 100000
        else: 
           gcc = abs(cc-ccbits)/scc

        if sra == 0:
          if ra-radbits == 0:
            gra = 0
          else:
            gra = 100000
        else: 
           gra = abs(ra-radbits)/sra

        if sdia == 0:
          if dia-diambits == 0:
            gdia = 0
          else:
            gdia = 100000
        else: 
           gdia = abs(dia-diambits)/sdia

        if sl == 0:
          if l-lbits == 0:
            gl = 0
          else:
            gl = 100000
        else: 
           gl = abs(l-lbits)/sl

        gof = (1/cnbits)* gcn + (6/ccbits)*gcc + (1/diambits)*gdia + (1/radbits)*gra + (6/lbits)*gl 

	print ip,kp,cn, scn, cc, scc, dia, sdia, ra, sra, l, sl, gof, rech

        os.chdir('..')

